using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace testAutMote
{
    public partial class TestAutMote : Form
    {
        CDriver_AutMote driverAutMote = null;

        public TestAutMote()
        {
            InitializeComponent();
            try
            {
                driverAutMote = new CDriver_AutMote();
                tbInfo.AppendText("Driver successfully created\r\n");

                if (!driverAutMote.InstantiateDriver("Driver_AutMote.dll"))
                    throw new Exception("Error instantiating driver");

                if ((driverAutMote.AddWordToLanguage("ENG", "00", "Back") > 0) || (driverAutMote.AddWordToLanguage("ENG", "01", "SEND") > 0) || (driverAutMote.AddWordToLanguage("ENG", "02", "Disconnected") > 0))
                    throw new Exception("Error adding words to a dictionnary");

                if (driverAutMote.AddUser("1234", "4321", "ENG", 3) > 0)
                    throw new Exception("Error adding new user");
            }
            catch (Exception ex)
            {
                tbInfo.AppendText("ERROR: " + ex.Message + "\r\n");
            }
        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            try
            {
                if (driverAutMote.Initiate(55600,"239.255.239.70",55600,"SERVICE TEST AUTMOTE")>0)
                    tbInfo.AppendText("Error initiating driver.\r\n");
                else
                    tbInfo.AppendText("Driver successfully initiated.\r\n");
            }
            catch (Exception ex)
            {
                tbInfo.AppendText("ERROR: " + ex.Message + "\r\n");
            }            
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            btnStop_Click(null, null);
            Close();
        }

        private void btnStop_Click(object sender, EventArgs e)
        {
            try
            {
                if (driverAutMote.Stop() > 0)
                    tbInfo.AppendText("Error stopping driver.\r\n");
                else
                    tbInfo.AppendText("Driver successfully stopped.\r\n");
            }
            catch (Exception ex)
            {
                tbInfo.AppendText("ERROR: " + ex.Message + "\r\n");
            }
        }

        private void btnRead_Click(object sender, EventArgs e)
        {
            try
            {
                System.Collections.ArrayList codeList = new System.Collections.ArrayList();
                System.Collections.ArrayList keyList = new System.Collections.ArrayList();

                if (driverAutMote.ReturnReceivedList(ref codeList, ref keyList) > 0)
                    tbInfo.AppendText("Error reading.\r\n");
                else
                {
                    if (codeList.Count == 0)
                        tbInfo.AppendText("Nothing received.\r\n");
                    else
                    {
                        tbInfo.AppendText("---- Received (Code,Key) ----\r\n");
                        for (int i = 0; i < codeList.Count; i++)
                            tbInfo.AppendText("(" + codeList[i] + "," + keyList[i] + ")\r\n");
                        tbInfo.AppendText("-----------------------------\r\n");
                    }
                }
            }
            catch (Exception ex)
            {
                tbInfo.AppendText("ERROR: " + ex.Message + "\r\n");
            }            
        }

        private void btnWrite_Click(object sender, EventArgs e)
        {
            try
            {
               driverAutMote.SendPrivateMessage("1234", tbMessage.Text);
            }
            catch (Exception ex)
            {
                tbInfo.AppendText("ERROR: " + ex.Message + "\r\n");
            }            
        }
    }
}